Imports System.IO
Imports MySql.Data
Imports MySql.Data.MySqlClient

Partial Class Innerjoin
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        ' When the page loads we get data from session variables to use in our select statements
        If Page.IsPostBack = False Then
            HiddenYearID.Value = Convert.ToString(Session("YearID"))
            HiddenCompanyName.Value = Convert.ToString(Session("CompanyName"))
        End If
    End Sub
    Protected Sub BtnCreateJournal_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles BtnCreateJournal.Click

        ' Code to select data from three tables with inner joins to connect the tables to each other
        ' The data is presented in an repeater control.
        Try
            Dim ConnString As String = ConfigurationManager.ConnectionStrings("ConnectionString").ToString()
            Dim sql As String = "SELECT T.TransID, T.Date, F.FinOwnID, F.FinName, T.Project, T.ResultUnit, " _
            & "I.CashAccount, I.BuyAccount, T.Antal, T.Value FROM FinanceTrans As T INNER JOIN FinanceObject " _
            & "As F ON T.FinanceObject = F.FID INNER JOIN FinanceInstrument As I ON F.InstrumentType = I.IID " _
            & "WHERE T.YearID = @YearID AND T.Accounted = '0' AND T.TransType = '0' AND T.Date <= @Slutdatum " _
            & "GROUP BY T.TransID, T.Date, F.FinOwnID, F.FinName, T.Project, T.ResultUnit, I.CashAccount, " _
            & "I.BuyAccount, T.Antal, T.Value ORDER BY T.Date ASC"

            ' The Using block is used to call dispose (close) automatically even if there are an exception.
            Using cn As New MySqlConnection(ConnString), _
                  cmd As New MySqlCommand(sql, cn)
                cmd.Parameters.Add("@Slutdatum", MySqlDbType.Date).Value = EndDateJournal.Text
                cmd.Parameters.Add("@YearID", MySqlDbType.Int64).Value = HiddenYearID.Value

                cn.Open()
                ' The Using block is used to call dispose (close) automatically even if there are an exception.
                Using reader As MySqlDataReader = cmd.ExecuteReader()
                    JournalRepeater.DataSource = reader
                    JournalRepeater.DataBind()
                End Using

            End Using
        Catch ex As Exception
            Response.Write(ex.Message)
        End Try

        ' Variables to calculate debetsum och creditsum
        Dim KreditSum As Decimal
        Dim DebetSum As Decimal

        ' Code to select cash account data from tables with inner joins to connect the tables to each other
        ' The data is presented in an repeater control.
        Try
            Dim ConnString As String = ConfigurationManager.ConnectionStrings("ConnectionString").ToString()
            Dim sql As String = "SELECT I.CashAccount, T.Project, T.ResultUnit, SUM(T.Value) As Kredit FROM " _
            & "FinanceTrans As T  INNER JOIN FinanceObject As F ON T.FinanceObject = F.FID INNER JOIN " _
            & "FinanceInstrument As I ON F.InstrumentType = I.IID WHERE T.YearID = @YearID AND T.Accounted " _
            & "= '0' AND T.TransType = '0' AND T.Date <= @Slutdatum GROUP BY I.CashAccount, T.Project, " _
            & "T.ResultUnit ORDER BY I.CashAccount ASC"

            ' The Using block is used to call dispose (close) automatically even if there are an exception.
            Using cn As New MySqlConnection(ConnString), _
                  ad As New MySqlDataAdapter(), _
                  cmd As New MySqlCommand(sql, cn)
                cmd.Parameters.Add("@Slutdatum", MySqlDbType.Date).Value = EndDateJournal.Text
                cmd.Parameters.Add("@YearID", MySqlDbType.Int64).Value = HiddenYearID.Value

                cn.Open()
                ad.SelectCommand = cmd

                ' The Using block is used to call dispose (close) automatically even if there are an exception.
                Using ds As New System.Data.DataSet()
                    ad.Fill(ds)
                    AccountCashRepeater.DataSource = ds
                    AccountCashRepeater.DataBind()
                    If Not DBNull.Value.Equals(ds.Tables(0).Compute("SUM(Kredit)", String.Empty)) Then
                        KreditSum = Convert.ToDecimal(ds.Tables(0).Compute("SUM(Kredit)", String.Empty))
                    End If
                End Using

            End Using
        Catch ex As Exception
            Response.Write(ex.Message)
        End Try

        ' Code to select purchase account data from tables with inner joins to connect the tables to each other
        ' The data is presented in an repeater control.
        Try
            Dim ConnString As String = ConfigurationManager.ConnectionStrings("ConnectionString").ToString()
            Dim sql As String = "SELECT I.BuyAccount, T.Project, T.ResultUnit, SUM(T.Value) As Debet FROM " _
            & "FinanceTrans As T INNER JOIN FinanceObject As F ON T.FinanceObject = F.FID INNER JOIN " _
            & "FinanceInstrument As I ON F.InstrumentType = I.IID WHERE T.YearID = @YearID AND T.Accounted = " _
            & "'0' AND T.TransType = '0' AND T.Date <= @Slutdatum GROUP BY I.BuyAccount, T.Project, " _
            & "T.ResultUnit ORDER BY I.BuyAccount ASC"

            ' The Using block is used to call dispose (close) automatically even if there are an exception.
            Using cn As New MySqlConnection(ConnString), _
                    ad As New MySqlDataAdapter(), _
                    cmd As New MySqlCommand(sql, cn)
                cmd.Parameters.Add("@Slutdatum", MySqlDbType.Date).Value = EndDateJournal.Text
                cmd.Parameters.Add("@YearID", MySqlDbType.Int64).Value = HiddenYearID.Value

                cn.Open()
                ad.SelectCommand = cmd

                ' The Using block is used to call dispose (close) automatically even if there are an exception.
                Using ds As New System.Data.DataSet()
                    ad.Fill(ds)
                    AccountBuyRepeater.DataSource = ds
                    AccountBuyRepeater.DataBind()
                    If Not DBNull.Value.Equals(ds.Tables(0).Compute("SUM(Debet)", String.Empty)) Then
                        DebetSum = Convert.ToDecimal(ds.Tables(0).Compute("SUM(Debet)", String.Empty))
                    End If
                End Using

            End Using
        Catch ex As Exception
            Response.Write(ex.Message)
        End Try

        ' Set debetsum and creditsum
        DebetLabel.Text = String.Format("{0:# ### ### ##0.00}", DebetSum)
        KreditLabel.Text = String.Format("{0:# ### ### ##0.00}", KreditSum)
        Sum.Visible = True
    End Sub
End Class
